/***************************************************************************
                         SP Mail project : Simple Powerful Mail
                          CMailFolders.cpp  -  description
                             -------------------
    begin                : 23 June 2003
    copyright            : (C) 2000-2003 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <sptk/CSmallPixmaps.h>

#include "CImapFolders.h"
#include "mailbox.xpm"

Fl_Pixmap mailboxPixmap(mailbox_xpm);

CImapFolders::CImapFolders(CRegistry& registry)
: CTreeView("",180,SP_ALIGN_LEFT), m_registry(registry) {
	end();
}

CImapFolders::~CImapFolders() {
}

void CImapFolders::loadAccounts() {
	m_accountsMap.clear();
	m_registry.topic("Accounts");
	int accountNumber = m_registry["account number"];
	for (int i = 0; i < accountNumber; i++) {
		m_registry.topic("Account " +CString(i));

		CString type = m_registry["type"];

		if (type == "IMAP") {
			CString name = m_registry["name"];
			CString server = m_registry["server"];
			CString user = m_registry["user"];
			CString password = m_registry["password"];

			CImapAccount *imapAccount = new CImapAccount(name,server,user,password);
			m_accountsMap.insert(name,imapAccount);
			imapAccount->loadFolders();
		}
	}
	createFolders();
}

void CImapFolders::readAccounts() {
}

void CImapFolders::clear() {
	CTreeView::clear();
	m_accountsMap.clear();
}

void CImapFolders::createFolders() {
	CTreeView::clear();
	CStringMapIterator<CImapAccount> itor(m_accountsMap);
	for (; *itor; itor++) {
		CImapAccount *imapAccount = *itor;
		const CStringList& folders = imapAccount->folders();

		CTreeItem* node = addItem(imapAccount->name(),&mailboxPixmap);
		for (unsigned i = 0; i < folders.count(); i++) {
			node->addPath(CStringList(folders[i],"/"),CSmallPixmaps::pixmaps[SXPM_FOLDER_OPENED],CSmallPixmaps::pixmaps[SXPM_FOLDER],CSmallPixmaps::pixmaps[SXPM_FOLDER_OPENED]);
		}
	}
	relayout();
}
