/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          integer_map.cpp  -  description
                             -------------------
    begin                : 13 June 2003
    copyright            : (C) 2000-2003 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef __BORLANDC__
#include <vcl.h>
#pragma hdrstop
#endif

#include <stdio.h>
#include <sptk/CException.h>
#include <sptk/CString.h>
#include <sptk/CIntMap.h>

class CTestData {
public:
	int     m_id;
	CString m_data;
	static int objectCounter; 
public:
   // Regular constructor
	CTestData(int id,CString data) {
		m_id = id;
		m_data = data;
		objectCounter++;
	}

   // Copy constructor
	CTestData(CTestData& td) {
		m_id = td.m_id;
		m_data = td.m_data;
		objectCounter++;
	}

	~CTestData() {
		objectCounter--;
	}

	void print() {
		printf("%i, %s\n",m_id,m_data.c_str());
	}
};

int CTestData::objectCounter;

int main( int argc, char *argv[] ) {
	puts("\n-------------------------\nFilling map.\n");
	try {
		CIntMap<CTestData> map;

		map.insert(14,new CTestData(14,"Tester 5"));
		map.insert(3, new CTestData(3,"Programmer"));
		map.insert(11,new CTestData(11,"Tester 2"));
		map.insert(31,new CTestData(31,"Agent 4"));
		map.insert(3, new CTestData(3,"DBA"));
		map.insert(13,new CTestData(13,"Tester 4"));
		map.insert(2, new CTestData(2,"Web master"));
		map.insert(1, new CTestData(1,"Manager"));
		map.insert(4, new CTestData(4,"Adviser"));
		map.insert(15,new CTestData(15,"Web master 2"));
		map.insert(24,new CTestData(24,"CEO 2"));
		map.insert(26,new CTestData(26,"CFO 1"));
		map.insert(5, new CTestData(5,"Pilot"));
		map.insert(17,new CTestData(17,"HR Director"));
		map.insert(12,new CTestData(12,"Tester 3"));
		map.insert(2, new CTestData(2,"Web admin"));
		map.insert(30,new CTestData(30,"Agent 3"));
		map.insert(10,new CTestData(10,"Tester 1"));
		map.insert(20,new CTestData(20,"IT Manager"));
		map.insert(21,new CTestData(21,"IT Director"));
		map.insert(22,new CTestData(22,"HR Director"));
		map.insert(17,new CTestData(17,"HR Manager"));
		map.insert(18,new CTestData(18,"CR Manager"));
		map.insert(23,new CTestData(23,"CEO"));
		map.insert(32,new CTestData(32,"Agent 5"));
		map.insert(27,new CTestData(27,"CFO 2"));
		map.insert(19,new CTestData(19,"Receptionist"));
		map.insert(28,new CTestData(28,"Agent 1"));
		map.insert(25,new CTestData(25,"CEO 3"));
		map.insert(29,new CTestData(29,"Agent 2"));

		puts("\n-------------------------\nPrinting map.\n");
        // Printing the test data
		CIntMapIterator<CTestData> itor(map);
		for (; *itor; itor++) {
			CTestData *ptr = *itor;
			ptr->print();
		}

		puts("\n-------------------------\nTesting element access.\n");
		CTestData& dt1 = map[1];
		dt1.print();

		CTestData& dt2 = map[3];
		dt2.print();
	}
	catch (CException& e) {
		puts(e.text().c_str());
	}

	if (CTestData::objectCounter > 0)
		puts("\nThe number of memory leaks is "+CString(CTestData::objectCounter));

	if (CTestData::objectCounter < 0)
		puts("\nThe number of double-freed objects is "+CString(-CTestData::objectCounter));

	if (CTestData::objectCounter == 0)
		puts("\nAll the objects released correctly\n");

	puts("\n-------------------------\nTest completed.");

	return 0;
}
