/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          string_map.cpp  -  description
                             -------------------
    begin                : 13 June 2003
    copyright            : (C) 2000-2003 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef __BORLANDC__
#include <vcl.h>
#pragma hdrstop
#endif

#include <map>
#include <string>

using namespace std;

#include <stdio.h>
#include <sptk/CException.h>
#include <sptk/CString.h>
#include <sptk/CStringMap.h>
#include <sptk/CStringList.h>
#include <sptk/CDateTime.h>

int main( int argc, char *argv[] ) {
	// Read the test file and parse it to words
	CStringList words;
	words.loadFromFile("../examples/speed_test.txt");
	CString buffer = words.asString(" ");
	words.fromString(buffer," ");

	unsigned wordCount = words.count();
	printf("Loaded %i words from file examples/speed_test.txt\n",wordCount);

	{
		puts("\nTest of STL map");
		CDateTime started = CDateTime::Now();
		map<string,string> map1;
		for (unsigned j = 0; j < 100; j++) {
			for (unsigned i = 0; i < wordCount; i++) {
				map1.insert(map<string,string>::value_type(words[i].c_str(),words[i].c_str()));
			}
		}

		CDateTime ended = CDateTime::Now();
		double seconds = (ended - started) * 24.0 * 3600.0;
		printf("Map includes %i elements\n",map1.size());
		printf("Test 1 completed for %0.2f sec\n",seconds);
	}

	{
		puts("\nTest of SPTK map");
		CDateTime started = CDateTime::Now();
		CStringMap<CString> map1;
		for (unsigned j = 0; j < 100; j++) {
			for (unsigned i = 0; i < wordCount; i++) {
				map1.insert(words[i].c_str(),words[i].c_str());
			}
		}

		CDateTime ended = CDateTime::Now();
		double seconds = (ended - started) * 24.0 * 3600.0;
		printf("Map includes %i elements\n",map1.count());
		printf("Test 1 completed for %0.2f sec\n",seconds);
	}

	return 0;
}
