/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                               SPTK TO ODBC BRIDGE
                          spbridge-server.cpp  -  description
                             -------------------
    begin                : Oct 6, 2003
    copyright            : (C) 2003 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
   This library is free software; you can redistribute it and/or modify it 
   under the terms of the GNU Library General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at 
   your option) any later version.

   This library is distributed in the hope that it will be useful, but 
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library
   General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

   Please report all bugs and problems to "alexeyp@gmail.com"
 ***************************************************************************/

#include <sptk/CBridgedDatabase.h>
#include <sptk/CQuery.h>
#include <iostream>

using namespace std;

int main(int argc,char *argv[]) {
   cout << "SPTK TO ODBC bridge client version 0.99" << endl;

   CBridgedDatabase database("localhost","DSN=ScriptorLink");
   CQuery *query = new CQuery(&database,"select count(*) from operator_list");
   try {
      database.open("DSN=ScriptorLink");
      query->open();
      query->close();
      database.close();
      puts("Client database closed.");
      delete query;
      puts("Query destroyed.");
   }
   catch (CException& e) {
      puts(e.text());
   }
   catch (...) {
      puts("Unknown error in spbridge-client");
   }
}
