/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          cevent.h  -  description
                             -------------------
    begin                : Thu Apr 27 2000
    copyright            : (C) 2000-2003 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
   This library is free software; you can redistribute it and/or modify it 
   under the terms of the GNU Library General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at 
   your option) any later version.

   This library is distributed in the hope that it will be useful, but 
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library
   General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

   Please report all bugs and problems to "alexeyp@gmail.com"
 ***************************************************************************/

#ifndef __CEVENT_H__
#define __CEVENT_H__

/// Event type constants
enum CEvent {
   CE_NONE,
   CE_DATA_CHANGED,
   CE_FOCUS,
   CE_UNFOCUS,
   CE_SHOW,
   CE_HIDE,
   CE_KEYBOARD,
   CE_MOUSE_CLICK, 
   CE_MOUSE_DOUBLE_CLICK,
   CE_MOUSE_DRAG, 
   CE_MOUSE_MOVE, 
   CE_MOUSE_RELEASE, 
   CE_MOUSE_WHEEL, 
   CE_PROGRESS,
   CE_BUTTON_PRESSED,
   UC_ADD_ITEM, 
   UC_EDIT_ITEM, 
   UC_DELETE_ITEM,
   UC_REFRESH, 
   CE_LAST_EVENT
};

/// Event type information
class CEventInfo {
   /// Event type
   CEvent        m_event;
   /// Event argument
   int           m_argument;
public:
   /// Constructor
   /// @param eventType CEvent, event type
   /// @param eventArg CEvent, event argument
   CEventInfo(CEvent eventType=CE_NONE,int eventArg=0) { m_event = eventType; m_argument = eventArg; }
   /// Reports event type
   CEvent  type() const { return m_event; }
   /// Reports event argument
   int     argument() const { return m_argument; }
};

#endif
