/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          cexception.h  -  description
                             -------------------
    begin                : Thu Apr 27 2000
    copyright            : (C) 2000-2003 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
   This library is free software; you can redistribute it and/or modify it 
   under the terms of the GNU Library General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at 
   your option) any later version.

   This library is distributed in the hope that it will be useful, but 
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library
   General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

   Please report all bugs and problems to "alexeyp@gmail.com"
 ***************************************************************************/

#ifndef __EXCEPTION_H__
#define __EXCEPTION_H__

#include <sptk/CString.h>

/// SPTK exception class. Contains information about what
/// happend and where
class SP_EXPORT CException {
	CString m_file;         ///< The file where exception occurs
	int     m_line;         ///< The line number in the file where exception occurs
	CString m_text;         ///< The exception text
	CString m_description;  ///< The extended error information
public:
   /// Constructor
   /// @param text CString, the exception text
   /// @param file CString, the file where exception occurs
   /// @param line int, the line number in the file where exception occurs
	/// @param description CString, the optional description information
	CException(const CString text,const CString file="",int line=0,CString description="");

   /// Returns text of exception
	CString text(bool shortVersion=false) const;
};

#endif
