/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          cintlist.h  -  description
                             -------------------
    begin                : Mon Apr 17 2000
    copyright            : (C) 2000-2003 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
   This library is free software; you can redistribute it and/or modify it 
   under the terms of the GNU Library General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at 
   your option) any later version.

   This library is distributed in the hope that it will be useful, but 
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library
   General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

   Please report all bugs and problems to "alexeyp@gmail.com"
 ***************************************************************************/

#ifndef __CINTLIST_H__
#define __CINTLIST_H__

#include <sptk/CList.h>
#include <sptk/CString.h>

class CControl;

/// A very simple list of integers
class SP_EXPORT CIntList : public CList {
public:
   /// Constructor
   CIntList() : CList() {}
   /// Element access by element index
   int operator [] (unsigned ind) const { return (int) m_items[ind]; }
   /// Adds a new element
   void add(int item) { CList::add((void *)item); }
   /// Assigns another CIntList
   CIntList& operator = (const CIntList& list);
   /// Converts to string as a list of values, separated with user-defined character
   /// (comma, by default)
   CString toString(const char * separator=",") const;
   /// Converts from string of a list of values, separated with user-defined character
   /// (comma, by default)
   void fromString(const char * s,const char * separator=",");
};

#endif
