/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          CExcelCell.h  -  description
                             -------------------
    begin                : Mon Jan 19 2004
    copyright            : (C) 2004 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
   This library is free software; you can redistribute it and/or modify it 
   under the terms of the GNU Library General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at 
   your option) any later version.

   This library is distributed in the hope that it will be useful, but 
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library
   General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

   Please report all bugs and problems to "alexeyp@gmail.com"
 ***************************************************************************/

#ifndef __CEXCELCELL_H__
#define __CEXCELCELL_H__

#include <sptk/CVariant.h>
#include <sptk/excel/CExcelCellFormat.h>

/// Represents an Excel cell in the memory
class CExcelCell : public CVariant {
   const CExcelCellFormat *m_format;  ///< An optional pointer to the cell format
public:
   /// Constructor
   CExcelCell() { m_format = 0L;  }

   /// Advanced copy constructor
   /// @param v const CVariant&, data to copy from
   /// @param format const CExcelCellFormat *, a cell format
   CExcelCell(const CVariant& v,const CExcelCellFormat *format=0L) : CVariant(v) { m_format = format; }

   /// Sets the cell format. NULL means the default formatting
   /// @param format const CExcelCellFormat *, a cell format
   void format(const CExcelCellFormat *format) { m_format = format; }

   /// Returns the cell format. NULL means the default formatting
   const CExcelCellFormat *format() const { return m_format; }
};

#endif
