#include "CClientThread.h"
#include <stdio.h>

CClientThread::CClientThread(CString threadName,int connectionFD)
: CThread(threadName,true) {
   puts(name()+" is created");

   m_socket.attach(connectionFD);
   m_odbcChannel = new CServerODBCChannel(&m_socket);
}

CClientThread::~CClientThread() {
   delete m_odbcChannel;
}

void CClientThread::threadFunction() {
   puts(name()+" is started");
   try {
      m_socket.open();
   }
   catch(CException& e) {
      puts(e.text());
   }

   puts("Processing..");

   while (m_odbcChannel->readCommand()) {}

   puts(name()+" is completed");
}
