/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                               SPTK TO ODBC BRIDGE
                          CServerODBCChannel.h  -  description
                             -------------------
    begin                : Jan 5, 2004
    copyright            : (C) 2003-2005 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
   This library is free software; you can redistribute it and/or modify it 
   under the terms of the GNU Library General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at 
   your option) any later version.

   This library is distributed in the hope that it will be useful, but 
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library
   General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

   Please report all bugs and problems to "alexeyp@gmail.com"
 ***************************************************************************/

#ifndef __CSERVERODBCCHANNEL_H__
#define __CSERVERODBCCHANNEL_H__

#include <sptk/CODBCDatabase.h>
#include "CODBCChannel.h"

class CServerODBCChannel;

class CServerODBCDatabase : public CODBCDatabase {
   friend class CServerODBCChannel;
public:
   /// Constructor
   /// @param connectionString CString, the ODBC connection string
   CServerODBCDatabase(CString connectionString = "") : CODBCDatabase(connectionString) {}
};

class CServerODBCChannel : public CODBCChannel {
   CServerODBCDatabase   m_database;
   CString               m_lastError;

   bool readCommand(CODBCCommandType command);
public:
   CServerODBCChannel(CSocket *socket);
   bool readCommand();
   void returnError();
   void returnOk();
};


#endif
