/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          CExcelNumericFormat.cpp  -  description
                             -------------------
    begin                : Fri May 6 2004
    copyright            : (C) 2000-2005 by Alexey S.Parshin
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
   This library is free software; you can redistribute it and/or modify it 
   under the terms of the GNU Library General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at 
   your option) any later version.

   This library is distributed in the hope that it will be useful, but 
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library
   General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

   Please report all bugs and problems to "alexeyp@gmail.com"
 ***************************************************************************/

#include <sptk/excel/CExcelNumericFormat.h>

CExcelNumericFormat::CExcelNumericFormat(CVariantType kind,unsigned index,CString format) {
	m_kind = kind;
	m_index = index;
	m_format = format;
}

CExcelNumericFormat::CExcelNumericFormat(unsigned index,CString format) {
	m_kind = VAR_STRING;
	m_index = index;
	m_format = format;

	CString lcFormat(format.lowerCase());
	if ( lcFormat.pos("$") > -1 ) {
		m_kind = VAR_MONEY;
	} else {
		if ( lcFormat.pos("mm") > -1
			|| lcFormat.pos("dd") > -1
			|| lcFormat.pos("yy") > -1
			|| lcFormat.pos("ss") > -1
			|| lcFormat.pos("hh") > -1 ) 
		{
			m_kind = VAR_STRING;
			if ( lcFormat.pos("d") > -1 || m_format.pos("y") > -1 )
				m_kind = VAR_DATE;
			if ( lcFormat.pos("s") > -1 || m_format.pos("h") > -1 )
				m_kind = VAR_DATE_TIME;
		} else {
			if ( lcFormat.pos(".0") > -1 )
				m_kind = VAR_FLOAT;
			else
				m_kind = VAR_STRING;
		}
	}
}

CExcelNumericFormat::CExcelNumericFormat(const CExcelNumericFormat& nf) {
	m_kind = nf.m_kind;
	m_index = nf.m_index;
	m_format = nf.m_format;
}

void CExcelNumericFormats::saveRecords(CExcelRecordsBuffer& records) {
	CIntMapIterator<CExcelNumericFormat> itor(this);
	for (;*itor;itor++) {
		CExcelNumericFormat *nf = *itor;
		int formatID = nf->index();
		int formatLength = nf->format().length();
		char *buffer = new char[ formatLength + 5 ];
		CExcelRecord::setshort(buffer,0,formatID);
		buffer[2] = char(formatLength);
		CExcelRecord::setshort(buffer,3,0);
		memcpy(buffer + 5,nf->format().c_str(),formatLength);
		records.append(FORMAT,formatLength + 5,buffer);
		delete buffer;
	}
}
